module Encoding.Base32
  ( enc32
  , dec32
  ) where


import Data.ByteString as B
import qualified Data.ByteString.Char8 as BC
import Data.ByteString.UTF8 as BSU      -- from utf8-string
import qualified Codec.Binary.Base32 as B32
import qualified Data.Text as T
import qualified Data.Text.Encoding as T
import qualified Data.Text.IO as T

-- dec32 :: String -> String
-- dec32 input =
--    case B32.decode (BSU.fromString input) of
--      Right decoded -> T.unpack (T.decodeUtf8 decoded)
--      Left _ -> "Error decoding Base32.\n"

dec32 :: B.ByteString -> B.ByteString
dec32 input = case B32.decode input of
                Right byteString -> byteString
                Left _ -> BC.pack "Error: Invalid Base32 input"

-- enc32 :: String -> String
-- enc32 = C.unpack . B32.encode . BSU.fromString

enc32 :: B.ByteString -> B.ByteString
enc32 = B32.encode
