-- module Encoding.Base8
--   ( enc8
--   , dec8
--   ) where

-- import Data.Char (ord, chr, intToDigit)

-- octalToChar :: String -> Char
-- octalToChar octal = chr (read ("0o" ++ octal))  -- Assumes input is in base 8 (octal)

-- -- Function to split a string into chunks of three characters each
-- chunksOf3 :: String -> [String]
-- chunksOf3 [] = []
-- chunksOf3 str = Prelude.take 3 str : chunksOf3 (Prelude.drop 3 str)

-- dec8 :: String -> String
-- dec8 =  map octalToChar . words

-- chunksOf :: Int -> [a] -> [[a]]
-- chunksOf _ [] = []
-- chunksOf n xs = Prelude.take n xs : chunksOf n (Prelude.drop n xs)

-- unicodeToOctal :: Char -> [String]
-- unicodeToOctal c = chunksOf 3 $ reverse $ decimalToOctal' (ord c)
--   where
--     decimalToOctal' 0 = "0"
--     decimalToOctal' m = let (q, r) = m `divMod` 8 in intToDigit r : if q == 0 then "" else decimalToOctal' q

-- enc8 :: String -> String
-- enc8 = unwords . concatMap unicodeToOctal

module Encoding.Base8
  ( enc8
  , dec8
  ) where

import Data.Char (ord, chr, intToDigit)
import qualified Data.ByteString.Char8 as BC
import Data.ByteString (ByteString)
import qualified Data.ByteString as B

octalToChar :: ByteString -> Char
octalToChar octal = chr (read ("0o" ++ BC.unpack octal))  -- Assumes input is in base 8 (octal)

chunksOf :: Int -> ByteString -> [ByteString]
chunksOf n bs
  | B.null bs = []
  | otherwise = BC.take n bs : chunksOf n (BC.drop n bs)

dec8 :: ByteString -> ByteString
dec8 = BC.pack . map octalToChar . BC.words

unicodeToOctal :: Char -> [ByteString]
unicodeToOctal c = chunksOf 3 (BC.pack $ reverse $ decimalToOctal' (ord c))
  where
    decimalToOctal' 0 = "0"
    decimalToOctal' m = let (q, r) = m `divMod` 8 in intToDigit r : if q == 0 then "" else decimalToOctal' q

enc8 :: ByteString -> ByteString
enc8 = BC.unwords . concatMap unicodeToOctal . BC.unpack
